<?php
// 应用公共文件

function __autoload($class){
    if(file_exists($GLOBALS['config']['socket_controller'].$class.'.php')) {
        require_once($GLOBALS['config']['socket_controller'].$class.'.php');
    }else{
        echo_log("找不到对应的文件: $class ".__LINE__);
    }
}

function echo_log($data,$data2=''){
	//如果打开了调试
	if(is_array($data) || is_object($data)) {
		var_dump(date("Y-m-d H:i:s") . $data);
	} else {
		echo(date("Y-m-d H:i:s") . $data);
	}
	echo("\r\n");
	if (!empty($data2)) {
		if(is_array($data2) || is_object($data2)) {
			var_dump(date("Y-m-d H:i:s") . $data2);
		} else {
			echo($data2);
		}
	}
	echo("\r\n\r\n");
}

function post_curl($url,$data,$header = array(), $is_ssl = false) {

	$ch = curl_init(); // 启动一个CURL会话
	curl_setopt($ch, CURLOPT_URL, $url); // 要访问的地址
	if ($is_ssl) {
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); // 从证书中检查SSL加密算法是否存在
		curl_setopt($ch, CURLOPT_SSLVERSION, 1); // 设定SSL版本,微信时候使用1，否则报错
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	}
	if ($data) {
		curl_setopt($ch, CURLOPT_POST, 1); // 发送一个常规的Post请求
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // Post提交的数据包
	}
	if ($header) {
		curl_setopt($ch,CURLOPT_HTTPHEADER,$header);
	}
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回

	$out = curl_exec($ch);
	$outArr = json_decode($out, true);
	if($outArr) {
		return $outArr;
	} else {
		return $out;
	}

}

function cache($config) {
	$con = new Redis();
	$con->connect($config['host'], $config['port']);
	if(!empty($config['auth'])){
		$this->auth($config['auth']);
	}
	return $con;
}

//解码(主要针对特殊符号和emoji表情)
function emoji_decode($str){
    if(empty($str)){
        return $str;
    }
    $str = preg_replace_callback('/@E(.{6}==)/', function ($r) {
        return base64_decode($r[1]);
    }, $str);
    return $str;
}

function createLoginToken($data)
{
    $arr = json_encode($arr);
    return base64_encode(uc_authcode($arr, 'ENCODE'));
}

function decryptToken($token)
{
    if($token){
        $val = uc_authcode(base64_decode($token),'DECODE');
        if(!empty($val)){
            $val = json_decode($val,true);
        }else{
            $val = false;
        }
        return $val;
    }else{
        return false;
    }
}

/**
 *功能：加密解密函数
 *@param string $string 要加密字符串
 *@param string $operation 动作 DECODE 解密， ENCODE 加密
 *@param string $key 加密key
 *@param int expiry
 *@return string 加密或解密的字符串
 */
function uc_authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
    $ckey_length = 4;
    $key = md5($key ? $key : '12R,sf2$1U5)kk#UI9.wiu');
    $keya = md5(substr($key, 0, 16));
    $keyb = md5(substr($key, 16, 16));
    $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

    $cryptkey = $keya.md5($keya.$keyc);
    $key_length = strlen($cryptkey);

    $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
    $string_length = strlen($string);

    $result = '';
    $box = range(0, 255);

    $rndkey = array();
    for($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($cryptkey[$i % $key_length]);
    }

    for($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }

    for($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;
        $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }

    if($operation == 'DECODE') {
        if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
            return substr($result, 26);
        } else {
            return '';
        }
    } else {
        return $keyc.str_replace('=', '', base64_encode($result));
    }
}

/***********************************socket公用方法start********************************************************/
//type为true时server地址+端口号 OR server地址
function host_prefix($type = true) {
	$re = $GLOBALS['config']['MAIN_SERVER']['IP'].':'.$GLOBALS['config']['MAIN_SERVER']['PORT'];
	if($type) {
		$re .= ':';
	}
	return $re;
}
//根据用户UID查用户的连接记录
function get_user_fd($uid){
	$uidJson = $GLOBALS['redisDB']->hget($GLOBALS['config']['HASH_TABLE']['UID'],$uid);
	if($uidJson) {
		$uidData = json_decode($uidJson,true);
		return $uidData['fd'];
	} else {
		return false;
	}
}
//根据用户的fd查用户的uid
function get_user_uid($fd){
	$fdJson = $GLOBALS['redisDB']->hget($GLOBALS['config']['HASH_TABLE']['FD'],host_prefix().$fd);
	if($fdJson) {
		$fdData = json_decode($fdJson,true);
		return $fdData['uid'];
	} else {
		return false;
	}
}

//设置用户在线
/*
$data = array(
	"fd"		=> ,//"连接",
	"uid"		=> ,//用户ID,
);
*/
function set_user_list($data){
	//删掉这个uid之前绑定的连接
	$uidJson = $GLOBALS['redisDB']->hget($GLOBALS['config']['HASH_TABLE']['UID'],$data['uid']);
	if($uidJson){
		$uidData = json_decode($uidJson,true);
		$GLOBALS['redisDB']->hdel($GLOBALS['config']['HASH_TABLE']['UID'],$data['uid']);
		$GLOBALS['redisDB']->hdel($GLOBALS['config']['HASH_TABLE']['FD'],host_prefix().$uidData['fd']);
	}

	$setData = array(
		'fd'=>$data['fd']
		,'uid'=>$data['uid']
		,'socket'=>host_prefix(false)
	);
	$setData = json_encode($setData);
	$GLOBALS['redisDB']->hset($GLOBALS['config']['HASH_TABLE']['UID'],$data['uid'],$setData);
	$GLOBALS['redisDB']->hset($GLOBALS['config']['HASH_TABLE']['FD'],host_prefix().$data['fd'],$setData);
	return true;
}

//删除用户在线数据
function del_user_list($fd) {
	$re = $GLOBALS['redisDB']->hdel($GLOBALS['config']['HASH_TABLE']['UID'],get_user_uid($fd));
	$re1 = $GLOBALS['redisDB']->hdel($GLOBALS['config']['HASH_TABLE']['FD'],host_prefix().$fd);
	return true;
}

//给某个用户发信息
function send_user($server,$uid,$data,$opcode=1,$finish=true){
	if(empty($uid)){
		return false;
	}
	$fd = get_user_fd($uid);
	//检测通道是否存在
	if(!empty($fd) && !$server->exist($fd)){
		echo_log("通道[ $fd ]的客户端已经断开,无法发送消息!\r\n",$data);
		unset($data);
		return false;
	}else{
		$server->push($fd,$data,$opcode,$finish);
		unset($data);
		return $finish;
	}
}

//给指定用户发信息（群发）
function send_group($server,$arr,$data,$opcode=1){
	if(!empty($arr)){
		foreach($arr as $uid){
			if(send_user($server,$uid,$data,$opcode)){
				echo_log('用户['. $uid .']发送消息成功!\r\n');
			}else{
				echo_log('用户['. $uid .']的客户端已经断开,无法发送消息!\r\n');
			}
		}
	}else{
		echo_log('没有指定要发信息的用户,无法发送消息!\r\n');
	}
	return true;
}

//给所有用户发信息
function send_all($server,$data,$opcode=1,$finish=true){
	$userList = $GLOBALS['redisDB']->HGETALL($GLOBALS['config']['HASH_TABLE']['UID']);
	if(!empty($userList)){
		foreach($userList as $key=>$val){
			$arr = json_decode($val,true);

			if(host_prefix(false) == $arr['socket']) {
				//发送消息给接收者
				$server->push($arr['fd'],json_encode($data),$opcode,$finish);
			} else {
				$postData = array(
					'to_uid'=>$key
					,'from_uid'=>'系统广播'
					,'content'=>$data['d']['content']
				);
				$postUrl = $arr['socket'].'?event=http_send_msg';
				$finish = post_curl($postUrl,$postData);
			}


			if($finish){
				echo_log('用户['. $key .']发送消息成功!\r\n');
			}else{
				echo_log('用户['. $key .']的客户端已经断开,无法发送消息!\r\n');
			}
		}
	}else{
		echo_log('没有指定要发信息的用户,无法发送消息!\r\n');
	}
	return true;
}
/***********************************socket公用方法end********************************************************/